# coding: utf-8
import requests
import json
import psycopg2
import uuid
import datetime  
import time
import hashlib  
import time
import hmac  
import base64  
import urllib.parse  
import hashlib
from collections import OrderedDict  
from urllib.parse import quote_plus

#全局变量，便于参数使用的预设值 
current_date = datetime.date.today()     # 获取当前日期 
previous_date = current_date - datetime.timedelta(days=1)  # 获取前一天日期 
formatted_current_date = current_date.strftime("%Y-%m-%dT%H:%M:%SZ")  # 获取当前日期 - 标准化
formatted_previous_date = previous_date.strftime("%Y-%m-%dT%H:%M:%SZ")  # 获取前一天日期 - 标准化
timestamp = time.time()       #  为Unix time，即从"1970-01-01 00:00:00"至今的秒数；
sign_version = 'v2'     # 签名版本号，固定值v2
nonce = str(uuid.uuid4())
current_time_utc =( datetime.datetime.now() - datetime.timedelta(hours=8)).strftime("%Y-%m-%dT%H:%M:%SZ")

formatted2_current_date = current_date.strftime("%Y-%m-%d %H:%M:%S")  # 获取当前日期 - 标准化
formatted2_previous_date = previous_date.strftime("%Y-%m-%d %H:%M:%S")  # 获取前一天日期 - 标准化

def formatted2_previous_hour(h):
    if h==0:
        return datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")
    start_of_current_hour = datetime.datetime.now().replace(minute=0, second=0, microsecond=0)  
    # 减去一个小时，得到前一个小时的开始时间  
    start_of_previous_hour = start_of_current_hour - datetime.timedelta(hours=h) 
    return start_of_previous_hour.strftime("%Y-%m-%d %H:%M:%S")

def previous_hour_timestamp(h):
    if h==0:
        return int(time.time())
    start_of_current_hour = datetime.datetime.now().replace(minute=0, second=0, microsecond=0)  
     # 减去一个小时，得到前一个小时的开始时间  
    start_of_previous_hour = start_of_current_hour - datetime.timedelta(hours=h) 
    return int(start_of_previous_hour.timestamp())
    
#计算签名
def generate_signature(str, private_key):
    signature = hmac.new(private_key.encode(), (str).encode(), hashlib.sha1)
    signature_b64 = base64.b64encode(signature.digest()).decode()
    return signature_b64

#构建查询链接
def build_query_string(params):  
    # 使用OrderedDict来保持排序  
    sorted_params = OrderedDict(sorted(params.items()))  
      
    # 拼接属性名和属性值，并使用&连接  
    query_string = '&'.join('{}={}'.format(  
        urllib.parse.quote_plus(k),   
        urllib.parse.quote_plus(str(v))  
    ) for k, v in sorted_params.items())        
    return query_string

#构建查询链接
def build_query_string(params):  
    # 使用OrderedDict来保持排序  
    sorted_params = OrderedDict(sorted(params.items()))  
      
    # 拼接属性名和属性值，并使用&连接  
    query_string = '&'.join('{}={}'.format(  
        urllib.parse.quote_plus(k),   
        urllib.parse.quote_plus(str(v))  
    ) for k, v in sorted_params.items())        
    return query_string


#计算签名，get请求
def request_list_signature_get():
    print('开始请求数据...')
    url='https://api-bj.clink.cn/crm/list_customers'
    param={'AccessKeyId':'b17759d3a36fba9a2cf522fbf4cbf177','Timestamp':current_time_utc,'Expires':86400,'updateStartTime':previous_hour_timestamp(1),'updateEndTime':previous_hour_timestamp(0)}
    # param={'AccessKeyId':'b17759d3a36fba9a2cf522fbf4cbf177','Timestamp':current_time_utc,'Expires':86400,'updateStartTime':1704038400,'updateEndTime':previous_hour_timestamp(0)}
    print(f'param: {param}')
    url_path = build_query_string(param)
    url_param = url_path
    print(f'url_param: {url_param}')
    url_param = f'GETapi-bj.clink.cn/crm/list_customers?{url_param}'
    print(f'待计算字符串: {url_param}')
    signature= generate_signature(url_param,'5g027B6w06630Y5240c1')
    print(f'计算签名: {signature}')
    print(f'编码后签名: {urllib.parse.quote_plus(signature)}')
    url = f'{url}?{url_path}&Signature={urllib.parse.quote_plus(signature)}'
    print(f'url: {url}')

    dataReqL=requests.get(url,headers={},params={})
    resText = dataReqL.text
    i = 0
    while 'error' in resText  and i < 5:
        print(f'请求客户资料列表失败，再次请求第{i+1}次')
        time.sleep(1)
        dataReqL=requests.get(url,headers={},params={})
        resText = dataReqL.text
        i = i + 1
    resL=json.loads(resText)
    return resL    

def request_detail_signature_post(customerId):
    print(f'开始请求客户详情：{formatted2_previous_hour(0)}')
    url='https://api-bj.clink.cn/crm/query_customer'
    header={'Content-Type':'application/json;charset=UTF-8'}
    param={'AccessKeyId':'b17759d3a36fba9a2cf522fbf4cbf177','Timestamp':current_time_utc,'Expires':86400}
    print(f'param: {param}')
    url_path = build_query_string(param)
    url_param = url_path
    print(f'url_param: {url_param}')
    url_param = f'POSTapi-bj.clink.cn/crm/query_customer?{url_param}'
    print(f'待计算字符串: {url_param}')
    signature= generate_signature(url_param,'5g027B6w06630Y5240c1')
    print(f'计算签名: {signature}')
    print(f'编码后签名: {urllib.parse.quote_plus(signature)}')
    url = f'{url}?{url_path}&Signature={urllib.parse.quote_plus(signature)}'
    print(f'url: {url}')

    body={'customerId':customerId}
    jsonData = json.dumps(body)
    print(f'body: {jsonData}')
    dataReqL=requests.post(url,headers=header,data=jsonData)
    resText = dataReqL.text
    i = 0
    while 'error' in resText  and i < 5:
        print(f'请求客户详情失败，再次请求第{i+1}次')
        time.sleep(1)
        dataReqL=requests.post(url,headers=header,params=body)
        i = i + 1
    resL=json.loads(resText)
    return resL

def load_data_to_db(dataList): 
    conn = psycopg2.connect(database="dataops_db", user="dbuser_dops", password="MIgTi3jA",host="172.17.0.8", port="5432")
    print('数据库连接成功')
    dataId=str(uuid.uuid4())
    total=len(dataList)
    print('临时id：'+dataId)
    json_object = json.dumps(dataList)
    cur=conn.cursor()
    sql="update data_api.api_data set is_loaded = '1' where api_id = 'c83284b6bbb148daa6b3d04173ab748f';INSERT INTO data_api.api_data (id,api_id,data,total_num,is_loaded,status,request_tm,execute_tm,remark) values (%s,%s,%s,%s,'0','0',current_timestamp(0),current_timestamp(0),'')"
    cur.execute(sql,[dataId,'c83284b6bbb148daa6b3d04173ab748f', json_object, total])
    conn.commit()
    cur.close()
    conn.close()
    print('加载数据结束：customer_list:获取客户资料列表')
    
def load_detail_data_to_db(ids, dataList): 
    conn = psycopg2.connect(database="dataops_db", user="dbuser_dops", password="MIgTi3jA",host="172.17.0.8", port="5432")
    print('数据库连接成功')
    dataId=str(uuid.uuid4())
    total=len(dataList)
    print('临时id：'+dataId)
    json_object = json.dumps(dataList)
    idstr = ','.join(ids)
    cur=conn.cursor()
    sql="update data_api.cc_details_ids_exp set is_loaded = '1' where api_id = '010d4668242c4b96b4964693edcf5556' and id in (%s); update data_api.cc_customer_details set is_loaded = '1' where api_id = '010d4668242c4b96b4964693edcf5556'; INSERT INTO data_api.cc_customer_details (id,api_id,data,total_num,is_loaded,status,request_tm,execute_tm,remark) values (%s,%s,%s,%s,'0','0',current_timestamp(0),current_timestamp(0),'')"
    cur.execute(sql,[idstr,dataId,'010d4668242c4b96b4964693edcf5556', json_object, total])
    conn.commit()
    cur.close()
    conn.close()
    print('加载数据结束：tickets_detail:获取客户资料详情')  

def load_detail_exp_to_db(id):
    try:
        print(f'添加查询客户资料异常记录:{id}')
        conn = psycopg2.connect(database="dataops_db", user="dbuser_dops", password="MIgTi3jA",host="172.17.0.8", port="5432")
        print('数据库连接成功')
        dataId=str(uuid.uuid4())
        print('临时id：'+dataId)
        cur=conn.cursor()
        sql=" INSERT INTO data_api.cc_details_ids_exp (id,api_id,is_loaded,status,request_tm,execute_tm,remark) values (%s,%s,'0','0',current_timestamp(0),current_timestamp(0),'')"
        cur.execute(sql,[id, '010d4668242c4b96b4964693edcf5556'])
        conn.commit()
        cur.close()
        conn.close()
        print(f'添加查询客户资料异常记录:{id} 结束')
    except Exception as e:  
        print(f'添加查询客户资料异常记录:{id}失败, 错误信息：{e}') 

if __name__ == "__main__":
    print(f'{formatted2_previous_hour(0)}开始请求客户资料信息')
    resL = request_list_signature_get()
    print(resL)
    if 'error' in resL:
        error = resL['error']
        print(f'请求客户资料列表失败，失败原因：{error}')
    else:
        dataList = resL['customers']
        load_data_to_db(dataList)
        detailDataList = []
        ids = []
        for data in  dataList:
            try: 
                for item in data:
                    if item['key'] == -1:
                        id=item['value']
                        print(f'客户id:{id},开始请求数据')
                        resD = request_detail_signature_post(id)
                        print(f'请求数据结束{id}')
                        if 'customer' in resD:
                            ids.append(id)
                            dataList = resD['customer']
                            detailDataList.append(dataList)
                        else:
                            error = resD['error']
                            print(f"请求客户资料详情（id:{id}）失败，错误信息：{error}")
                            load_detail_exp_to_db(id)
            except Exception as e:  
                print(f'请求客户资料详情（id:{id}）异常,异常信息：{e}')
                load_detail_exp_to_db(data['id'])
        print(f'444:{ids}')
        if len(ids) > 0:
            ids_str = [str(item) for item in ids]
            load_detail_data_to_db(ids_str,detailDataList)
    print(f'{formatted2_previous_hour(0)}请求客户资料信息结束')          